
<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>uiLabels: Go Coverage Report</title>
		<style>
			body {
				background: black;
				color: rgb(80, 80, 80);
			}
			body, pre, #legend span {
				font-family: Menlo, monospace;
				font-weight: bold;
			}
			#topbar {
				background: black;
				position: fixed;
				top: 0; left: 0; right: 0;
				height: 42px;
				border-bottom: 1px solid rgb(80, 80, 80);
			}
			#content {
				margin-top: 50px;
			}
			#nav, #legend {
				float: left;
				margin-left: 10px;
			}
			#legend {
				margin-top: 12px;
			}
			#nav {
				margin-top: 10px;
			}
			#legend span {
				margin: 0 5px;
			}
			.cov0 { color: rgb(192, 0, 0) }
.cov1 { color: rgb(128, 128, 128) }
.cov2 { color: rgb(116, 140, 131) }
.cov3 { color: rgb(104, 152, 134) }
.cov4 { color: rgb(92, 164, 137) }
.cov5 { color: rgb(80, 176, 140) }
.cov6 { color: rgb(68, 188, 143) }
.cov7 { color: rgb(56, 200, 146) }
.cov8 { color: rgb(44, 212, 149) }
.cov9 { color: rgb(32, 224, 152) }
.cov10 { color: rgb(20, 236, 155) }

		</style>
	</head>
	<body>
		<div id="topbar">
			<div id="nav">
				<select id="files">
				
				<option value="file0">github.com/liturgiko/doxa/pkg/uiLabels/benchmark-tests.go (0.0%)</option>
				
				<option value="file1">github.com/liturgiko/doxa/pkg/uiLabels/uiLabels.go (100.0%)</option>
				
				</select>
			</div>
			<div id="legend">
				<span>not tracked</span>
			
				<span class="cov0">not covered</span>
				<span class="cov8">covered</span>
			
			</div>
		</div>
		<div id="content">
		
		<pre class="file" id="file0" style="display: none">// Package uiLabels provides a thread-safe way to manage and access UI labels in multiple languages.
//
// Running the benchmarks:
//
// # Run all benchmarks
// go test -bench=.
//
// # Run specific benchmark
// go test -bench=BenchmarkGet
//
// # Run benchmarks with more iterations for better statistics
// go test -bench=. -benchtime=5s
//
// # See memory allocations during benchmarks
// go test -bench=. -benchmem
//
// # Profile CPU usage
// go test -bench=. -cpuprofile=cpu.out
// go tool pprof cpu.out
//
// # Profile memory usage
// go test -bench=. -memprofile=mem.out
// go tool pprof mem.out
package uiLabels

import (
        "sync"
        "testing"
)

// Test data for benchmark tests
var benchTranslations = map[string]map[string]string{
        "priest": {
                "en": "Priest",
                "es": "Sacerdote",
                "sw": "Kasisi",
        },
        "deacon": {
                "en": "Deacon",
                "es": "Diácono",
                "sw": "Shemasi",
        },
        "choir": {
                "en": "Choir",
                "es": "Coro",
                "sw": "Kwaya",
        },
        "lChoir": {
                "en": "Left Choir",
                "es": "Coro Izquierdo",
                "sw": "Kwaya ya Kushoto",
        },
        "rChoir": {
                "en": "Right Choir",
                "es": "Coro Derecho",
                "sw": "Kwaya ya Kulia",
        },
}

// BenchmarkGet benchmarks the Get method (read operation)
func BenchmarkGet(b *testing.B) <span class="cov0" title="0">{
        labels := NewLabels()
        labels.SetBulk(benchTranslations)

        b.ResetTimer()
        for i := 0; i &lt; b.N; i++ </span><span class="cov0" title="0">{
                // Cycle through different abbreviations and languages
                abbr := "priest"
                lang := "en"

                switch i % 5 </span>{
                case 0:<span class="cov0" title="0">
                        abbr = "priest"</span>
                case 1:<span class="cov0" title="0">
                        abbr = "deacon"</span>
                case 2:<span class="cov0" title="0">
                        abbr = "choir"</span>
                case 3:<span class="cov0" title="0">
                        abbr = "lChoir"</span>
                case 4:<span class="cov0" title="0">
                        abbr = "rChoir"</span>
                }

                <span class="cov0" title="0">switch i % 3 </span>{
                case 0:<span class="cov0" title="0">
                        lang = "en"</span>
                case 1:<span class="cov0" title="0">
                        lang = "es"</span>
                case 2:<span class="cov0" title="0">
                        lang = "sw"</span>
                }

                <span class="cov0" title="0">_, _ = labels.Get(abbr, lang)</span>
        }
}

// BenchmarkGetWithFallback benchmarks the GetWithFallback method
func BenchmarkGetWithFallback(b *testing.B) <span class="cov0" title="0">{
        labels := NewLabels()
        labels.SetBulk(benchTranslations)

        b.ResetTimer()
        for i := 0; i &lt; b.N; i++ </span><span class="cov0" title="0">{
                // Cycle through different abbreviations
                abbr := "priest"
                switch i % 5 </span>{
                case 0:<span class="cov0" title="0">
                        abbr = "priest"</span>
                case 1:<span class="cov0" title="0">
                        abbr = "deacon"</span>
                case 2:<span class="cov0" title="0">
                        abbr = "choir"</span>
                case 3:<span class="cov0" title="0">
                        abbr = "lChoir"</span>
                case 4:<span class="cov0" title="0">
                        abbr = "rChoir"</span>
                }

                // Sometimes use an unavailable language to test fallback
                <span class="cov0" title="0">if i%3 == 0 </span><span class="cov0" title="0">{
                        // This will use fallback
                        _, _ = labels.GetWithFallback(abbr, "fr", "en")
                }</span> else<span class="cov0" title="0"> {
                        // This won't need fallback
                        _, _ = labels.GetWithFallback(abbr, "es", "en")
                }</span>
        }
}

// BenchmarkSet benchmarks the Set method (write operation)
func BenchmarkSet(b *testing.B) <span class="cov0" title="0">{
        labels := NewLabels()

        b.ResetTimer()
        for i := 0; i &lt; b.N; i++ </span><span class="cov0" title="0">{
                abbr := "bench" + string(rune(i%10+'0'))
                lang := "lang" + string(rune(i%5+'0'))
                translation := "Translation " + string(rune(i%20+'0'))

                labels.Set(abbr, lang, translation)
        }</span>
}

// BenchmarkConcurrentRead benchmarks concurrent read operations
func BenchmarkConcurrentRead(b *testing.B) <span class="cov0" title="0">{
        labels := NewLabels()
        labels.SetBulk(benchTranslations)

        // Fixed number of goroutines
        const numGoroutines = 100

        b.ResetTimer()

        // Run the benchmark
        b.RunParallel(func(pb *testing.PB) </span><span class="cov0" title="0">{
                // Each goroutine will execute this loop until pb.Next() returns false
                counter := 0
                for pb.Next() </span><span class="cov0" title="0">{
                        abbr := "priest"
                        lang := "en"

                        // Mix up the queries
                        switch counter % 5 </span>{
                        case 0:<span class="cov0" title="0">
                                abbr = "priest"</span>
                        case 1:<span class="cov0" title="0">
                                abbr = "deacon"</span>
                        case 2:<span class="cov0" title="0">
                                abbr = "choir"</span>
                        case 3:<span class="cov0" title="0">
                                abbr = "lChoir"</span>
                        case 4:<span class="cov0" title="0">
                                abbr = "rChoir"</span>
                        }

                        <span class="cov0" title="0">switch counter % 3 </span>{
                        case 0:<span class="cov0" title="0">
                                lang = "en"</span>
                        case 1:<span class="cov0" title="0">
                                lang = "es"</span>
                        case 2:<span class="cov0" title="0">
                                lang = "sw"</span>
                        }

                        <span class="cov0" title="0">_, _ = labels.Get(abbr, lang)
                        counter++</span>
                }
        })
}

// BenchmarkMixedReadWrite benchmarks a realistic scenario with mostly reads and occasional writes
func BenchmarkMixedReadWrite(b *testing.B) <span class="cov0" title="0">{
        labels := NewLabels()
        labels.SetBulk(benchTranslations)

        var mutex sync.Mutex
        writeCounter := 0

        b.ResetTimer()

        b.RunParallel(func(pb *testing.PB) </span><span class="cov0" title="0">{
                counter := 0
                for pb.Next() </span><span class="cov0" title="0">{
                        // Mostly reads (95%) with occasional writes (5%)
                        if counter%20 == 0 </span><span class="cov0" title="0">{
                                // Acquire counter to ensure we're not all writing at the same moment
                                mutex.Lock()
                                localWriteCounter := writeCounter
                                writeCounter++
                                mutex.Unlock()

                                // Perform a write operation
                                abbr := "write" + string(rune(localWriteCounter%10+'0'))
                                lang := "lang" + string(rune(localWriteCounter%5+'0'))
                                translation := "Write Translation " + string(rune(localWriteCounter%20+'0'))

                                labels.Set(abbr, lang, translation)
                        }</span> else<span class="cov0" title="0"> {
                                // Perform a read operation
                                abbr := "priest"
                                lang := "en"

                                switch counter % 5 </span>{
                                case 0:<span class="cov0" title="0">
                                        abbr = "priest"</span>
                                case 1:<span class="cov0" title="0">
                                        abbr = "deacon"</span>
                                case 2:<span class="cov0" title="0">
                                        abbr = "choir"</span>
                                case 3:<span class="cov0" title="0">
                                        abbr = "lChoir"</span>
                                case 4:<span class="cov0" title="0">
                                        abbr = "rChoir"</span>
                                }

                                <span class="cov0" title="0">switch counter % 3 </span>{
                                case 0:<span class="cov0" title="0">
                                        lang = "en"</span>
                                case 1:<span class="cov0" title="0">
                                        lang = "es"</span>
                                case 2:<span class="cov0" title="0">
                                        lang = "sw"</span>
                                }

                                <span class="cov0" title="0">_, _ = labels.Get(abbr, lang)</span>
                        }
                        <span class="cov0" title="0">counter++</span>
                }
        })
}

// BenchmarkGetLanguages benchmarks the GetLanguages method
func BenchmarkGetLanguages(b *testing.B) <span class="cov0" title="0">{
        labels := NewLabels()
        labels.SetBulk(benchTranslations)

        b.ResetTimer()
        for i := 0; i &lt; b.N; i++ </span><span class="cov0" title="0">{
                // Cycle through different abbreviations
                abbr := "priest"
                switch i % 5 </span>{
                case 0:<span class="cov0" title="0">
                        abbr = "priest"</span>
                case 1:<span class="cov0" title="0">
                        abbr = "deacon"</span>
                case 2:<span class="cov0" title="0">
                        abbr = "choir"</span>
                case 3:<span class="cov0" title="0">
                        abbr = "lChoir"</span>
                case 4:<span class="cov0" title="0">
                        abbr = "rChoir"</span>
                }

                <span class="cov0" title="0">_ = labels.GetLanguages(abbr)</span>
        }
}

// BenchmarkGetAllAbbreviations benchmarks the GetAllAbbreviations method
func BenchmarkGetAllAbbreviations(b *testing.B) <span class="cov0" title="0">{
        labels := NewLabels()
        labels.SetBulk(benchTranslations)

        b.ResetTimer()
        for i := 0; i &lt; b.N; i++ </span><span class="cov0" title="0">{
                _ = labels.GetAllAbbreviations()
        }</span>
}
</pre>
		
		<pre class="file" id="file1" style="display: none">// Package uiLabels provides a thread-safe way to manage and access UI labels
// in multiple languages. It is optimized for read-heavy workloads where
// writes primarily happen during initialization with rare updates afterward.
package uiLabels

import (
        "sync"
)

// Labels represents a thread-safe collection of UI labels in multiple languages.
// It's optimized for frequent reads and infrequent writes.
type Labels struct {
        // RWMutex provides read-write locking mechanism
        // Multiple goroutines can acquire read lock simultaneously
        // Write operations get exclusive access
        mu sync.RWMutex

        // Map stores UI labels where:
        // - First key is the label abbreviation (e.g., "li")
        // - Second key is the ISO language code (e.g., "en", "es")
        // - Value is the translated string
        Map map[string]map[string]string
}

// NewLabels creates and returns a new Labels instance
func NewLabels() *Labels <span class="cov8" title="1">{
        return &amp;Labels{
                Map: make(map[string]map[string]string),
        }
}</span>

// Get retrieves a translated label for the given abbreviation and language code.
// It returns the translated string and a boolean indicating if the label was found.
func (l *Labels) Get(abbr, langCode string) (string, bool) <span class="cov8" title="1">{
        l.mu.RLock()
        defer l.mu.RUnlock()

        if translations, exists := l.Map[abbr]; exists </span><span class="cov8" title="1">{
                if translation, langExists := translations[langCode]; langExists </span><span class="cov8" title="1">{
                        return translation, true
                }</span>
        }

        <span class="cov8" title="1">return "", false</span>
}

// GetWithFallback retrieves a translated label with fallback to a default language.
// If the requested language is not available, it falls back to the provided default.
func (l *Labels) GetWithFallback(abbr, langCode, fallbackLang string) (string, bool) <span class="cov8" title="1">{
        l.mu.RLock()
        defer l.mu.RUnlock()

        if translations, exists := l.Map[abbr]; exists </span><span class="cov8" title="1">{
                // Try the requested language first
                if translation, langExists := translations[langCode]; langExists </span><span class="cov8" title="1">{
                        return translation, true
                }</span>

                // Fall back to the fallback language
                <span class="cov8" title="1">if translation, fallbackExists := translations[fallbackLang]; fallbackExists </span><span class="cov8" title="1">{
                        return translation, true
                }</span>
        }

        <span class="cov8" title="1">return "", false</span>
}

// Set adds or updates a translation for a specific abbreviation and language.
func (l *Labels) Set(abbr, langCode, translation string) <span class="cov8" title="1">{
        l.mu.Lock()
        defer l.mu.Unlock()

        if _, exists := l.Map[abbr]; !exists </span><span class="cov8" title="1">{
                l.Map[abbr] = make(map[string]string)
        }</span>

        <span class="cov8" title="1">l.Map[abbr][langCode] = translation</span>
}

// SetBulk adds or updates multiple translations at once.
// The input is a map of abbreviations to a map of language codes to translations.
func (l *Labels) SetBulk(translations map[string]map[string]string) <span class="cov8" title="1">{
        l.mu.Lock()
        defer l.mu.Unlock()

        for abbr, langMap := range translations </span><span class="cov8" title="1">{
                if _, exists := l.Map[abbr]; !exists </span><span class="cov8" title="1">{
                        l.Map[abbr] = make(map[string]string)
                }</span>

                <span class="cov8" title="1">for langCode, translation := range langMap </span><span class="cov8" title="1">{
                        l.Map[abbr][langCode] = translation
                }</span>
        }
}

// Delete removes a translation for a specific abbreviation and language.
func (l *Labels) Delete(abbr, langCode string) <span class="cov8" title="1">{
        l.mu.Lock()
        defer l.mu.Unlock()

        if translations, exists := l.Map[abbr]; exists </span><span class="cov8" title="1">{
                delete(translations, langCode)

                // If no more translations for this abbreviation, clean up
                if len(translations) == 0 </span><span class="cov8" title="1">{
                        delete(l.Map, abbr)
                }</span>
        }
}

// DeleteAbbr removes all translations for a specific abbreviation.
func (l *Labels) DeleteAbbr(abbr string) <span class="cov8" title="1">{
        l.mu.Lock()
        defer l.mu.Unlock()

        delete(l.Map, abbr)
}</span>

// GetLanguages returns all available language codes for a specific abbreviation.
func (l *Labels) GetLanguages(abbr string) []string <span class="cov8" title="1">{
        l.mu.RLock()
        defer l.mu.RUnlock()

        if translations, exists := l.Map[abbr]; exists </span><span class="cov8" title="1">{
                languages := make([]string, 0, len(translations))

                for langCode := range translations </span><span class="cov8" title="1">{
                        languages = append(languages, langCode)
                }</span>

                <span class="cov8" title="1">return languages</span>
        }

        <span class="cov8" title="1">return []string{}</span>
}

// GetAllAbbreviations returns all available abbreviations.
func (l *Labels) GetAllAbbreviations() []string <span class="cov8" title="1">{
        l.mu.RLock()
        defer l.mu.RUnlock()

        abbreviations := make([]string, 0, len(l.Map))

        for abbr := range l.Map </span><span class="cov8" title="1">{
                abbreviations = append(abbreviations, abbr)
        }</span>

        <span class="cov8" title="1">return abbreviations</span>
}
</pre>
		
		</div>
	</body>
	<script>
	(function() {
		var files = document.getElementById('files');
		var visible;
		files.addEventListener('change', onChange, false);
		function select(part) {
			if (visible)
				visible.style.display = 'none';
			visible = document.getElementById(part);
			if (!visible)
				return;
			files.value = part;
			visible.style.display = 'block';
			location.hash = part;
		}
		function onChange() {
			select(files.value);
			window.scrollTo(0, 0);
		}
		if (location.hash != "") {
			select(location.hash.substr(1));
		}
		if (!visible) {
			select("file0");
		}
	})();
	</script>
</html>
